#include <MacroPatternMatch.h>
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttFill.h"
#include "TBranch.h"
#include "HROOTTreeTBranch.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TNAMED_DEF_VIRT(TBranch)
TATTFILL_DEF_VIRT(TBranch)
TOBJECT_DEF_VIRT(TBranch)
DELETABLE_DEF_VIRT(TBranch)

TBRANCH_DEF_VIRT(TBranch)

TBRANCH_DEF_NONVIRT(TBranch)

