#include <MacroPatternMatch.h>
#include "HROOTTreeTTree.h"
#include "TChain.h"
#include "HROOTTreeTChain.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TTREE_DEF_VIRT(TChain)
TNAMED_DEF_VIRT(TChain)
TATTLINE_DEF_VIRT(TChain)
TATTFILL_DEF_VIRT(TChain)
TATTMARKER_DEF_VIRT(TChain)
TOBJECT_DEF_VIRT(TChain)
DELETABLE_DEF_VIRT(TChain)

TCHAIN_DEF_VIRT(TChain)

TCHAIN_DEF_NONVIRT(TChain)

