{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Tree.TBranch.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Tree.TBranch.RawType
import HROOT.Tree.TBranch.FFI
import HROOT.Tree.TBranch.Interface
import HROOT.Tree.TBranch.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITBranch TBranch

instance ITNamed TBranch where
        setName = xform1 c_tbranch_setname
        setNameTitle = xform2 c_tbranch_setnametitle
        setTitle = xform1 c_tbranch_settitle

instance ITAttFill TBranch where
        setFillColor = xform1 c_tbranch_setfillcolor
        setFillStyle = xform1 c_tbranch_setfillstyle

instance ITObject TBranch where
        draw = xform1 c_tbranch_draw
        findObject = xform1 c_tbranch_findobject
        getName = xform0 c_tbranch_getname
        isA = xform0 c_tbranch_isa
        paint = xform1 c_tbranch_paint
        printObj = xform1 c_tbranch_printobj
        saveAs = xform2 c_tbranch_saveas
        write = xform3 c_tbranch_write

instance IDeletable TBranch where
        delete = xform0 c_tbranch_delete
