{-# LANGUAGE ForeignFunctionInterface #-}
module HROOT.Tree.TBranch.FFI where
import Foreign.C
import Foreign.Ptr
import HROOT.Tree.TBranch.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall safe "HROOTTreeTBranch.h TBranch_SetName"
               c_tbranch_setname :: Ptr RawTBranch -> CString -> IO ()

foreign import ccall safe "HROOTTreeTBranch.h TBranch_SetNameTitle"
               c_tbranch_setnametitle ::
               Ptr RawTBranch -> CString -> CString -> IO ()

foreign import ccall safe "HROOTTreeTBranch.h TBranch_SetTitle"
               c_tbranch_settitle :: Ptr RawTBranch -> CString -> IO ()

foreign import ccall safe "HROOTTreeTBranch.h TBranch_SetFillColor"
               c_tbranch_setfillcolor :: Ptr RawTBranch -> CInt -> IO ()

foreign import ccall safe "HROOTTreeTBranch.h TBranch_SetFillStyle"
               c_tbranch_setfillstyle :: Ptr RawTBranch -> CInt -> IO ()

foreign import ccall safe "HROOTTreeTBranch.h TBranch_Draw"
               c_tbranch_draw :: Ptr RawTBranch -> CString -> IO ()

foreign import ccall safe "HROOTTreeTBranch.h TBranch_FindObject"
               c_tbranch_findobject ::
               Ptr RawTBranch -> CString -> IO (Ptr RawTObject)

foreign import ccall safe "HROOTTreeTBranch.h TBranch_GetName"
               c_tbranch_getname :: Ptr RawTBranch -> IO CString

foreign import ccall safe "HROOTTreeTBranch.h TBranch_IsA"
               c_tbranch_isa :: Ptr RawTBranch -> IO (Ptr RawTClass)

foreign import ccall safe "HROOTTreeTBranch.h TBranch_Paint"
               c_tbranch_paint :: Ptr RawTBranch -> CString -> IO ()

foreign import ccall safe "HROOTTreeTBranch.h TBranch_printObj"
               c_tbranch_printobj :: Ptr RawTBranch -> CString -> IO ()

foreign import ccall safe "HROOTTreeTBranch.h TBranch_SaveAs"
               c_tbranch_saveas :: Ptr RawTBranch -> CString -> CString -> IO ()

foreign import ccall safe "HROOTTreeTBranch.h TBranch_Write"
               c_tbranch_write ::
               Ptr RawTBranch -> CString -> CInt -> CInt -> IO CInt

foreign import ccall safe "HROOTTreeTBranch.h TBranch_delete"
               c_tbranch_delete :: Ptr RawTBranch -> IO ()
